/*
 *
 *                         DES SOFTWARE PACKAGE
 *                             Version 2.2
 *
 *                                        _
 * Copyright (c) 1990,1991,1992,1993 Stig Ostholm.
 * All Rights Reserved
 *
 *
 * The author takes no responsibility of actions caused by the use of this
 * software package and does not guarantee the correctness of the functions.
 *
 * This software package may be freely distributed for non-commercial purpose
 * as long as the copyright notice is kept. Any changes made should be
 * accompanied by a comment indicating who made the change, when it was made
 * and what was changed.
 *
 * This software package, or any parts of it, may not be used or in any way
 * re-distributed for commercial purpose without the authors permission.
 * The author keeps the right to decide between of what is commercial and
 * what is non-commercial purpose.
 *
 * Restrictions due to national laws governing the use, import or export of
 * cryptographic software is the responsibility of the software user/importer/
 * exporter to follow.
 *
 *
 *                                              _
 *                                         Stig Ostholm
 *                                         Chalmers University of Technology
 *                                         Department of Computer Engineering
 *                                         S-412 96 Gothenburg
 *                                         Sweden
 *                                         ----------------------------------
 *                                         Email: ostholm@ce.chalmers.se
 *                                         Phone: +46 31 772 1703
 *                                         Fax:   +46 31 772 3663
 */

/*
 * The permutation P as described in FIPS 46 1977 January 15.
 *
 * The permuted input has bit 16 pf the input block as its first bit,
 * bit 7 as it second bit, and so on with bit 25 as its last bit.
 */

#define P_ROWS		8
#define P_COLUMNS	4

#ifdef __SDTC__
const
#endif
	unsigned char	p[P_ROWS][P_COLUMNS] = {
				{ 16,  7, 20, 21 },
				{ 29, 12, 28, 17 },
				{  1, 15, 23, 26 },
				{  5, 18, 31, 10 },
				{  2,  8, 24, 14 },
				{ 32, 27,  3,  9 },
				{ 19, 13, 30,  6 },
				{ 22, 11,  4, 25 }
			};
